org.eclipse.viatra.query.runtime.matchers.psystem.basicdeferred

## Class ExportedParameter

- java.lang.Object
- - org.eclipse.viatra.query.runtime.matchers.psystem.BasePConstraint
  - - org.eclipse.viatra.query.runtime.matchers.psystem.DeferredPConstraint
    - - org.eclipse.viatra.query.runtime.matchers.psystem.VariableDeferredPConstraint
      - - org.eclipse.viatra.query.runtime.matchers.psystem.basicdeferred.ExportedParameter

- All Implemented Interfaces:
    PConstraint, PTraceable

      public class ExportedParameter
      extends VariableDeferredPConstraint

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.eclipse.viatra.query.runtime.matchers.psystem.PConstraint

      `PConstraint.CompareByMonotonousID`

  - ### Field Summary

    - ### Fields inherited from class org.eclipse.viatra.query.runtime.matchers.psystem.BasePConstraint

      `pBody`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ExportedParameter(PBody pBody, PVariable parameterVariable, PParameter patternParameter)`
    `ExportedParameter(PBody pBody, PVariable parameterVariable, java.lang.String parameterName)` Deprecated. Use `ExportedParameter(PBody, PVariable, PParameter)` instead

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `checkSanity()`
    `void` | `doReplaceVariable(PVariable obsolete, PVariable replacement)`
    `java.util.Set<PVariable>` | `getDeducedVariables()` The set of variables whose potential values can be enumerated (once all non-deduced variables have known values).
    `java.util.Set<PVariable>` | `getDeferringVariables()`
    `java.lang.String` | `getParameterName()` The name of the parameter; usually, it is expected that `getParameterVariable()` is more useful, except maybe for debugging purposes.
    `PVariable` | `getParameterVariable()`
    `PParameter` | `getPatternParameter()`
    `protected java.lang.String` | `toStringRest()`

    - ### Methods inherited from class org.eclipse.viatra.query.runtime.matchers.psystem.VariableDeferredPConstraint

      `isReadyAt`

    - ### Methods inherited from class org.eclipse.viatra.query.runtime.matchers.psystem.BasePConstraint

      `delete, getAffectedVariables, getFunctionalDependencies, getMonotonousID, getPSystem, replaceVariable, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### ExportedParameter

          public ExportedParameter(PBody pBody,
                                   PVariable parameterVariable,
                                   PParameter patternParameter)

      Since:
        1.4

    - #### ExportedParameter

          @Deprecated
          public ExportedParameter(PBody pBody,
                                               PVariable parameterVariable,
                                               java.lang.String parameterName)

      Deprecated. Use `ExportedParameter(PBody, PVariable, PParameter)` instead

  - ### Method Detail

    - #### doReplaceVariable

          public void doReplaceVariable(PVariable obsolete,
                                        PVariable replacement)

      Specified by:
        `doReplaceVariable` in class `BasePConstraint`

    - #### toStringRest

          protected java.lang.String toStringRest()

      Specified by:
        `toStringRest` in class `BasePConstraint`

    - #### getDeducedVariables

          public java.util.Set<PVariable> getDeducedVariables()

      Description copied from interface: `PConstraint`
      The set of variables whose potential values can be enumerated (once all non-deduced variables have known values).

    - #### getParameterName

          public java.lang.String getParameterName()

      The name of the parameter; usually, it is expected that `getParameterVariable()` is more useful, except maybe for debugging purposes.
      Returns:
        a non-null name of the parameter

    - #### getParameterVariable

          public PVariable getParameterVariable()

    - #### getPatternParameter

          public PParameter getPatternParameter()

      Since:
        1.4

    - #### getDeferringVariables

          public java.util.Set<PVariable> getDeferringVariables()

      Specified by:
        `getDeferringVariables` in class `VariableDeferredPConstraint`

    - #### checkSanity

          public void checkSanity()
                           throws QueryProcessingException

      Specified by:
        `checkSanity` in interface `PConstraint`
      Overrides:
        `checkSanity` in class `BasePConstraint`
      Throws:
        `QueryProcessingException`